
	list      p=12F629     ; list directive to define processor
	#include <p12f629.inc>    ; processor specific variable definitions

	__CONFIG  _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _LP_OSC  &   _MCLRE_ON & _CPD_OFF


 
;Variables 

RTCC      EQU 1       
PC        EQU 2
STATUS    EQU 3      
 
GPIO  EQU 5
CMCON EQU 019H
ANSEL EQU 09FH
 

	ORG   0x00      ;reset vector
    GOTO START

    ORG   0x04      ;interrupt vector
    BSF GPIO,1      ;switch on LED FOR 1 mS
    BCF PIR1,0
  
	   
    MOVLW 0xE0      ;reload timer1
 	MOVWF TMR1H

    MOVLW 0x08
    MOVWF TMR1L
    RETFIE
  
	

START 
  	BCF STATUS,RP0  ;BANK 0
	        

 	MOVLW 7
 	MOVWF CMCON     ;DISABLE COMPARATOR
	CLRF GPIO
 
 
  
	BSF STATUS,RP0	; BANK1
   	CLRF ANSEL
    BSF INTCON,7
    BSF INTCON,6
     
   

    MOVLW B'00001'	
	MOVWF TRISIO          
	
    BCF PIR1,0
    BSF PIE1,0
 
    BCF STATUS,RP0	; change back to PORT memory bank
	
	
 
    MOVLW B'00001101'             
 	MOVWF T1CON

    MOVLW 0xff      ;clear timer1
 	MOVWF TMR1H

    MOVLW 0xfe
    MOVWF TMR1L
;Main 
   
 
WAIT                ;simple loop waiting for timer1 to time-out and generate an interrupt
    BCF GPIO,1
   
    GOTO WAIT       
  
  
 
     END




