
	list      p=12F629     ; list directive to define processor
	#include <p12f629.inc>    ; processor specific variable definitions

	__CONFIG  _CP_OFF & _WDT_ON & _BODEN_OFF & _PWRTE_ON & _LP_OSC  &   _MCLRE_ON & _CPD_OFF




;******************************************************************************
;Defines
;******************************************************************************

#define Bank0		0x00
#define	Bank1		0x80
#define SWITCH		GPIO,3
#define D0_1Tris	B'00000010'
#define D0On		B'00010000'
#define D0Off		B'00000000'
#define LEDOn		Flags,0

;******************************************************************************
;General Purpose Registers (GPR's) 
;******************************************************************************

;******************************************************************************
;Reset Vector 
;******************************************************************************

RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
 
GPIO  EQU 5
CMCON EQU 019H
ANSEL EQU 09FH
 

	ORG   0x00 
    
	

 
  	BCF STATUS,RP0    ;BANK 0
	        

 	MOVLW 7
 	MOVWF CMCON         ;DISABLE COMPARATOR
	CLRF GPIO
 
 	CLRF ANSEL
  
	BSF STATUS,RP0		; BANK1
    BCF INTCON,7
   
     
    MOVLW B'00001'	
	MOVWF TRISIO          
	
     MOVLW B'00001101' 
    MOVWF  OPTION_REG
  
	BCF STATUS,RP0		; change back to PORT memory bank


	
CYCLE  
    BCF GPIO,1  ;LED OFF
    CLRWDT
    SLEEP
    BSF GPIO,1  ;LED ON
    NOP
    NOP
    NOP
    GOTO CYCLE 

  
 
 
     END




