        LIST    p=16F84

 #include <p16F84.inc>

PTION EQU 081H
INTCON EQU 0BH

RTCC      EQU 1      ;RTCC
STATUS    EQU 3      ;STATUS REGISTER
THIRTYTWO EQU 010H   ;MODULUS 32 COUNTER

BUZZ   EQU 011H
TONE   EQU 012H
MSEC_20 EQU 013H
DB1 EQU 014H
GP  EQU 015H
DB2 EQU 016H
TONE2 EQU 017H
COUNTR   EQU 018H

LBYTE EQU 019H
HBYTE EQU 01AH
LONG EQU 01BH
LED EQU 0

PORTA EQU 5
PORTB EQU 6

LSN EQU 0
MSN EQU 1
GONG EQU 01CH
SAVE2  EQU 01DH




        ORG 0
     GOTO INIT

        ORG 4
     BCF INTCON,1
   
       RETFIE


INIT

      MOVLW 1
      TRIS PORTB
      MOVLW 0FFH
      MOVWF PORTB

      MOVLW 3
      TRIS PORTA

      BSF PORTA,2
      BSF PORTA,3
       BSF PORTA,4   ;BUZZER OFF

      MOVLW B'10000111'

      OPTION
      CALL SECOND

     BSF INTCON,4
     BCF INTCON,3
     BCF INTCON,7    
                 
     BSF STATUS,5    
     BCF PTION,6
     BCF STATUS,5   
                  
     MOVLW 2
     MOVWF TONE

NN NOP
   CALL ALARM
   CALL QUARTER
   CALL ALARM
   CALL QUARTER
   DECFSZ TONE,1
   GOTO NN

ENABLE


     BSF INTCON,7  ; ENABLE GLOBAL
     BSF INTCON,4  ; ENABLE GLOBAL
      CLRWDT
      SLEEP


                   MOVLW 0
                   MOVWF HBYTE
                   MOVLW 0
                   MOVWF LBYTE
     CALL ALARM
HERE

    CALL QUARTER
    BTFSS PORTB,0
    GOTO HERE

CY
   GOTO TEST
XXX
    CALL QUARTER
    BTFSC PORTB,0
    GOTO CY

     CALL ALARM
     CALL QUARTER
     CALL ALARM
     CALL QUARTER

     BCF PORTA,2    
     BCF PORTA,3

    ;TENS
     MOVF HBYTE,0
     XORLW 0
     BTFSC STATUS,2
     GOTO D


H    MOVLW 0AH
     MOVWF LONG
E    CALL MIN
     DECFSZ LONG,1
     GOTO E

     DECFSZ HBYTE,1
     GOTO H



D   ;UNITS
    MOVF LBYTE,0
    XORLW 0
    BTFSC STATUS,2
    GOTO F

G   CALL MIN
    DECFSZ LBYTE,1
    GOTO G

F

   

   NOP
   MOVLW 2
   MOVWF GONG
NP CALL VARI
   CALL QUARTERS
   CALL VARI
   CALL QUARTERS
   BTFSS PORTA,1
   GOTO NP

   GOTO ENABLE


TEST



     CALL QUARTER

     BTFSS PORTA,LSN
     GOTO C
     INCF LBYTE,1
     MOVF LBYTE,0
     XORLW 0AH
     BTFSS STATUS,2
     GOTO C
     MOVLW 0
     MOVWF LBYTE

C

     BTFSS PORTA,MSN
     GOTO BB
     INCF HBYTE,1
     MOVF HBYTE,0
     XORLW 0AH
     BTFSS STATUS,2
     GOTO BB
     MOVLW 0
     MOVWF HBYTE


BB

    MOVLW .4     
    MOVWF THIRTYTWO   
    CLRF RTCC        

LHORT BTFSC RTCC,7    
      GOTO JMPX       
  

      BCF PORTA,3
      BSF PORTA,2  ; TENS


      MOVF HBYTE,0
      XORLW 0
      BTFSC STATUS,2
      CALL ZERO
      MOVF HBYTE,0
      XORLW 1
      BTFSC STATUS,2
      CALL ONE
      MOVF HBYTE,0
      XORLW 2
      BTFSC STATUS,2
      CALL TWO
      MOVF HBYTE,0
      XORLW 3
      BTFSC STATUS,2
      CALL THREE
      MOVF HBYTE,0
      XORLW 4
      BTFSC STATUS,2
      CALL FOUR
      MOVF HBYTE,0
      XORLW 5
      BTFSC STATUS,2
      CALL FIVE
      MOVF HBYTE,0
      XORLW 6
      BTFSC STATUS,2
      CALL SIX
      MOVF HBYTE,0
      XORLW 7
      BTFSC STATUS,2
      CALL SEVEN
      MOVF HBYTE,0
      XORLW 8
      BTFSC STATUS,2
      CALL EIGHT
      MOVF HBYTE,0
      XORLW 9
      BTFSC STATUS,2
      CALL NINE


      BCF PORTA,2
      BSF PORTA,3  ;UNITS

      MOVF LBYTE,0
      XORLW 0
      BTFSC STATUS,2
      CALL ZERO
      MOVF LBYTE,0
      XORLW 1
      BTFSC STATUS,2
      CALL ONE
      MOVF LBYTE,0
      XORLW 2
      BTFSC STATUS,2
      CALL TWO
      MOVF LBYTE,0
      XORLW 3
      BTFSC STATUS,2
      CALL THREE
      MOVF LBYTE,0
      XORLW 4
      BTFSC STATUS,2
      CALL FOUR
      MOVF LBYTE,0
      XORLW 5
      BTFSC STATUS,2
      CALL FIVE
      MOVF LBYTE,0
      XORLW 6
      BTFSC STATUS,2
      CALL SIX
      MOVF LBYTE,0
      XORLW 7
      BTFSC STATUS,2
      CALL SEVEN
      MOVF LBYTE,0
      XORLW 8
      BTFSC STATUS,2
      CALL EIGHT
      MOVF LBYTE,0
      XORLW 9
      BTFSC STATUS,2
      CALL NINE





      CLRWDT
      GOTO LHORT

JMPX CLRF RTCC
                     ;32 LOOP COUNTER

    DECFSZ THIRTYTWO,1
    GOTO LHORT

       MOVLW 0FFH        ;ALL OFF
       MOVWF PORTB

      BCF PORTA,3  ;UNITS
      BCF PORTA,2  ;TENS

      GOTO XXX



ZERO
      BCF PORTB,7
      BCF PORTB,1
      BCF PORTB,2
      BCF PORTB,3
      BCF PORTB,4
      BCF PORTB,5
      CALL MS15

      BSF PORTB,7
      BSF PORTB,1
      BSF PORTB,2
      BSF PORTB,3
      BSF PORTB,4
      BSF PORTB,5
      RETLW 0

ONE
      BCF PORTB,5
      BCF PORTB,7
      CALL MS15

      BSF PORTB,5
      BSF PORTB,7
      RETLW 0

TWO

       BCF PORTB,1
       BCF PORTB,7
       BCF PORTB,6
       BCF PORTB,3
       BCF PORTB,4
      CALL MS15

       BSF PORTB,1
       BSF PORTB,7
       BSF PORTB,6
       BSF PORTB,3
       BSF PORTB,4

        RETLW 0

THREE


      BCF PORTB,1
      BCF PORTB,6
      BCF PORTB,4
      BCF PORTB,7
      BCF PORTB,5
      CALL MS15

      BSF PORTB,1
      BSF PORTB,6
      BSF PORTB,4
      BSF PORTB,7
      BSF PORTB,5

        RETLW 0


FOUR

      BCF PORTB,7
      BCF PORTB,5
      BCF PORTB,6
      BCF PORTB,2
      CALL MS15

      BSF PORTB,7
      BSF PORTB,5
      BSF PORTB,6
      BSF PORTB,2

      RETLW 0

FIVE

      BCF PORTB,1
      BCF PORTB,6
      BCF PORTB,4
      BCF PORTB,2
      BCF PORTB,5
      CALL MS15

      BSF PORTB,1
      BSF PORTB,6
      BSF PORTB,4
      BSF PORTB,2
      BSF PORTB,5

     RETLW 0

SIX

      BCF PORTB,6
      BCF PORTB,3
      BCF PORTB,4
      BCF PORTB,5
      BCF PORTB,2
      CALL MS15

      BSF PORTB,6
      BSF PORTB,3
      BSF PORTB,4
      BSF PORTB,5
      BSF PORTB,2

      RETLW 0

SEVEN

      BCF PORTB,1
      BCF PORTB,7
      BCF PORTB,5
      CALL MS15

      BSF PORTB,1
      BSF PORTB,7
      BSF PORTB,5

      RETLW 0

EIGHT


      BCF PORTB,1
      BCF PORTB,2
      BCF PORTB,3
      BCF PORTB,4
      BCF PORTB,5
      BCF PORTB,6
      BCF PORTB,7
      CALL MS15

      BSF PORTB,1
      BSF PORTB,2
      BSF PORTB,3
      BSF PORTB,4
      BSF PORTB,5
      BSF PORTB,6
      BSF PORTB,7
      RETLW 0

NINE
      BCF PORTB,1
      BCF PORTB,2
      BCF PORTB,6
      BCF PORTB,7
      BCF PORTB,5
      CALL MS15

      BSF PORTB,1
      BSF PORTB,2
      BSF PORTB,6
      BSF PORTB,7
      BSF PORTB,5

      RETLW 0







ALARM
     MOVLW 0FFH
     MOVWF TONE2
JJ
     MOVLW 042H
     MOVWF BUZZ
     BCF PORTA,4
GG   DECFSZ BUZZ,1
     GOTO GG
     BSF PORTA,4
     MOVLW 042H
     MOVWF BUZZ
HH   DECFSZ BUZZ,1
     GOTO HH
     DECFSZ TONE2,1
      GOTO JJ

    RETLW 0


MIN  MOVLW .59     ;1  MINUTE
     MOVWF TONE

COUNTMUX   BCF PORTA,4    



    MOVLW .32  ;32
    MOVWF THIRTYTWO   
    CLRF RTCC         

AHORT BTFSC RTCC,7    
                      
      GOTO JMP3
      CLRWDT
      BTFSC RTCC,2    
      BSF PORTA,4

      GOTO AHORT

JMP3 CLRF RTCC
                      
    DECFSZ THIRTYTWO,1
    GOTO AHORT

     BCF PORTA,2      
     BSF PORTA,3
                     
    BCF PORTB,7       

    MOVLW .100
    MOVWF THIRTYTWO
CFV   NOP
      NOP
    DECFSZ THIRTYTWO,1
    GOTO CFV


     BCF PORTA,2   ;DISLAY OFF
     BCF PORTA,3
                    ;
    BSF PORTB,7      ;LED OFF


    DECFSZ TONE,1
    GOTO COUNTMUX

    RETLW 0



SECOND

    MOVLW .31  ;32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

SHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2
      CLRWDT
      GOTO SHORT

JMP2 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORT


    BCF PORTB,7

     BCF PORTA,2   ;DISLAY OFF
     BCF PORTA,3


    RETLW 0


QUARTERS

    MOVLW .8
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

IIORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO IIP5
      CLRWDT
      GOTO IIORT

IIP5 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO IIORT
    RETLW 0




QUARTER

    MOVLW .2
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

BHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP5
      CLRWDT
      GOTO BHORT

JMP5 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO BHORT
    RETLW 0

MS15 MOVLW 010H
     MOVWF COUNTR
LOOP5

     NOP
     NOP
     NOP
     NOP
     NOP
     DECFSZ COUNTR,1
     GOTO LOOP5
     RETLW 0

VARI   ;BUZZER 2 TONE
     INCF GONG,1
     MOVF GONG,0
     MOVWF SAVE2

VARIO
     MOVLW 080H
     MOVWF TONE2
JJJ
     MOVLW 021H
     MOVWF BUZZ
     BCF PORTA,4
GGG  DECFSZ BUZZ,1
     GOTO GGG
     BSF PORTA,4
     MOVLW 042H
     MOVWF BUZZ
HHH  DECFSZ BUZZ,1
     GOTO HHH
     DECFSZ TONE2,1
     GOTO JJJ
     DECFSZ GONG,1
     GOTO  VARIO

    MOVF SAVE2,0
    MOVWF GONG
    RETLW 0
      END

