        LIST    p=16F84

DEBOUNCE EQU 01FH   ;0FFH
E         EQU 7      ;RB7   LCD
RS        EQU 6      ;RB6   LCD


DO        EQU 6
DI        EQU 7

S_CLK     EQU 2       ;PORT B
S_DATA    EQU 3       ;PORT B

INTCON    EQU 0BH


INDEX     EQU 0
RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
FSR       EQU 4
PORT_A    EQU 5      ;PORT A  LCD DATA BUS
PORT_B    EQU 6      ;PORT B  CONTROL/MONITOR


COUNTER   EQU 0CH    ;ADDRESS  COUNTER
A_N       EQU 0DH    ;ALPHANUMERIC COUNTER
ADDRESS   EQU 0EH    ;LCD ADDRESS
COUNTR    EQU 0FH
BUFFER    EQU 010H
DATABYTE  EQU 011H
DLYCNT    EQU 012H
ASCII     EQU 013H
LCDDATA   EQU 014H
CELL1     EQU 015H
CELL15    EQU 016H
CODES     EQU 017H

DATAI     EQU 018H
DATAO     EQU 019H
SLAVE     EQU 01AH
EEPROM    EQU 01BH
TXBUF     EQU 01CH
THIRTYTWO   EQU 01DH
ADDR      EQU 01EH
SAVEB      EQU 01FH
SAVE       EQU 020H
COUNT      EQU 021H

        ORG 0
    MOVLW 0
    TRIS PORT_A

    MOVLW B'00010000'
    TRIS PORT_B
    BCF PORT_B,RS
    BCF PORT_B,E
    MOVLW 0FH
    MOVWF PORT_A


    CALL INIT_DISPLAY

     MOVLW 0A9H      ; 0A9H
     CALL COMMAND



    MOVLW 'R'
    CALL WRITEDATA
    MOVLW '.'
    CALL WRITEDATA
    MOVLW 'G'
    CALL WRITEDATA
    MOVLW 'R'
    CALL WRITEDATA
    MOVLW 'O'
    CALL WRITEDATA
    MOVLW 'D'
    CALL WRITEDATA
    MOVLW 'Z'
    CALL WRITEDATA
    MOVLW 'I'
    CALL WRITEDATA
    MOVLW 'K'
    CALL WRITEDATA
    MOVLW '{'
    CALL WRITEDATA
    MOVLW 'c'
    CALL WRITEDATA
    MOVLW '}'
    CALL WRITEDATA
    MOVLW '2'
    CALL WRITEDATA
    MOVLW '0'
    CALL WRITEDATA
    MOVLW '0'
    CALL WRITEDATA
    MOVLW '4'
    CALL WRITEDATA

    MOVLW 082H
   CALL COMMAND
    MOVLW ':'
    CALL WRITEDATA

    MOVLW 085H
   CALL COMMAND
    MOVLW ':'
    CALL WRITEDATA


    MOVLW 088H
   CALL COMMAND
    MOVLW '.'
    CALL WRITEDATA

HERE
     MOVLW B'00000111'
     OPTION
   ; BSF INTCON,3

    MOVLW B'00010000'
    TRIS PORT_B
    ; SLEEP


      NOP
  ; BCF INTCON,0

  ;......................................



     MOVLW B'10100000'
     MOVWF SLAVE

     MOVLW 4     ;MINUTES =3       DATE=5
     MOVWF ADDR

     CALL BSTART
     MOVF SLAVE,W
     MOVWF TXBUF
     CALL TX
     MOVF ADDR,W
     MOVWF TXBUF
     CALL TX
     CALL BSTART
     MOVLW B'10100001'  ;READ
     MOVWF TXBUF
     CALL TX


     CALL RX
     MOVF DATAI,W
     CALL TRANSMIT2
     BSF EEPROM,DO
     CALL BITOUT
     CALL BSTOP

   ;CALL SECOND


     MOVLW B'10100000'
     MOVWF SLAVE

     MOVLW 3     ;HOURS=4    5=MONTH
     MOVWF ADDR
    ;CLRF ADDR

     CALL BSTART
     MOVF SLAVE,W
     MOVWF TXBUF
     CALL TX
     MOVF ADDR,W
     MOVWF TXBUF
     CALL TX
     CALL BSTART
     MOVLW B'10100001'  ;READ
     MOVWF TXBUF
     CALL TX


     CALL RX
     MOVF DATAI,W
     CALL TRANSMIT
     BSF EEPROM,DO
     CALL BITOUT
     CALL BSTOP

   ;CALL SECOND


     MOVLW B'10100000'
     MOVWF SLAVE

     MOVLW 2     ;HOURS=4    5=MONTH
     MOVWF ADDR
    ;CLRF ADDR

     CALL BSTART
     MOVF SLAVE,W
     MOVWF TXBUF
     CALL TX
     MOVF ADDR,W
     MOVWF TXBUF
     CALL TX
     CALL BSTART
     MOVLW B'10100001'  ;READ
     MOVWF TXBUF
     CALL TX


     CALL RX
     MOVF DATAI,W
     CALL TRANSMIT3
     BSF EEPROM,DO
     CALL BITOUT
     CALL BSTOP



     MOVLW B'10100000'
     MOVWF SLAVE

     MOVLW 1     ;HOURS=4    5=MONTH
     MOVWF ADDR
    ;CLRF ADDR

     CALL BSTART
     MOVF SLAVE,W
     MOVWF TXBUF
     CALL TX
     MOVF ADDR,W
     MOVWF TXBUF
     CALL TX
     CALL BSTART
     MOVLW B'10100001'  ;READ
     MOVWF TXBUF
     CALL TX


     CALL RX
     MOVLW 01FH
     ANDWF DATAI,1

     MOVF DATAI,W
     CALL TRANSMIT4
     BSF EEPROM,DO
     CALL BITOUT
     CALL BSTOP

   ; CALL SECOND
   ; CALL SECOND

     GOTO HERE



TRANSMIT3
       MOVLW 087H
       CALL COMMAND
       MOVF DATAI,0
       MOVWF SAVEB
      MOVLW 0FH
      ANDWF DATAI,0

    CALL BINARY
    CALL WRITEDATA

       MOVLW 086H
       CALL COMMAND


    SWAPF SAVEB,1
    MOVLW  0FH      ;
    ANDWF SAVEB,0

    CALL BINARY
    CALL WRITEDATA

    RETLW 0


TRANSMIT4
       MOVLW 08AH
       CALL COMMAND
       MOVF DATAI,0
       MOVWF SAVEB
      MOVLW 0FH
      ANDWF DATAI,0

    CALL BINARY
    CALL WRITEDATA

       MOVLW 089H
       CALL COMMAND


    SWAPF SAVEB,1
    MOVLW  0FH      ;
    ANDWF SAVEB,0

    CALL BINARY
    CALL WRITEDATA

    RETLW 0





TRANSMIT2
       MOVLW 081H
       CALL COMMAND
       MOVF DATAI,0
       MOVWF SAVEB
      MOVLW 0FH
      ANDWF DATAI,0

    CALL BINARY
    CALL WRITEDATA

       MOVLW 080H
       CALL COMMAND


    SWAPF SAVEB,1
    MOVLW  0FH      ;
    ANDWF SAVEB,0

    CALL BINARY
    CALL WRITEDATA

    RETLW 0

TRANSMIT

       MOVLW 084H
       CALL COMMAND
       MOVF DATAI,0
       MOVWF SAVEB
      MOVLW 0FH
      ANDWF DATAI,0

    CALL BINARY
    CALL WRITEDATA

       MOVLW 083H
       CALL COMMAND


    SWAPF SAVEB,1
    MOVLW  0FH      ;
    ANDWF SAVEB,0


    CALL BINARY

    CALL WRITEDATA

    RETLW 0


COMMAND
    MOVWF LCDDATA
    SWAPF LCDDATA,0    ;MSNIBBLE
    MOVWF PORT_A
    BCF PORT_B,RS
    BSF PORT_B,E
    CALL LDELAY
    BCF PORT_B,E

    MOVF LCDDATA,0    ;LSNIBBLE
    MOVWF PORT_A
    BCF PORT_B,RS
    BSF PORT_B,E
    CALL LDELAY
    BCF PORT_B,E

    RETLW 0

WRITEDATA
    MOVWF A_N
    SWAPF A_N,0
    MOVWF PORT_A
    BSF PORT_B,RS
    BSF  PORT_B,E
    CALL DELAY_DATA
    BCF PORT_B,E

    MOVF A_N,0
    MOVWF PORT_A
    BSF PORT_B,RS
    BSF  PORT_B,E
    CALL DELAY_DATA
    BCF PORT_B,E

    RETLW 0



BINARY
    ADDWF PC
    RETLW '0'
    RETLW '1'
    RETLW '2'
    RETLW '3'
    RETLW '4'
    RETLW '5'
    RETLW '6'
    RETLW '7'
    RETLW '8'
    RETLW '9'


DELAY1ST
    MOVF CELL15,0
    MOVWF DLYCNT
REDA DECFSZ DLYCNT,1
    GOTO REDA
    CLRWDT
    RETLW 0

DELAY
    MOVF CELL1,0
    MOVWF DLYCNT
REDO DECFSZ DLYCNT,1
    GOTO REDO
    CLRWDT
    RETLW 0


INIT_DISPLAY
    CALL LDELAY

    MOVLW 033H
    CALL COMMAND
    MOVLW 032H
    CALL COMMAND
    MOVLW 028H
    CALL COMMAND
    MOVLW 6
    CALL COMMAND
    MOVLW 0CH       ;OEH
    CALL COMMAND
    MOVLW 1
    CALL COMMAND
    CALL LDELAY
    RETLW 0

LDELAY
      MOVLW B'00000011'
      OPTION
      CLRF RTCC
L_DELAY
      CLRWDT
      BTFSS RTCC,7
      GOTO L_DELAY
      RETLW 0

DELAY_DATA
      MOVLW DEBOUNCE
      MOVWF DLYCNT
REDB DECFSZ DLYCNT,1
      goto REDB
      CLRWDT
      RETLW 0

SECOND
    MOVLW B'00000111';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC

    MOVLW .32
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

SHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP2
      CLRWDT
      GOTO SHORT

JMP2 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO SHORT
    RETLW 0


BSTART
   BSF PORT_B,S_DATA
   MOVLW 0
   TRIS PORT_B
   BCF PORT_B,S_CLK
   BSF PORT_B,S_CLK
   BCF PORT_B,S_DATA
   BCF PORT_B,S_CLK
   RETLW 0

BSTOP
   MOVLW 0
   TRIS PORT_B
   BCF PORT_B,S_DATA
   BSF PORT_B,S_CLK
   BSF PORT_B,S_DATA
   BCF PORT_B,S_CLK
   RETLW 0




BITIN
    BSF EEPROM,DI
    MOVLW B'00001000'
    TRIS PORT_B
     BSF PORT_B,S_DATA
     NOP
     NOP
     NOP
     NOP
    BSF PORT_B,S_CLK
    CLRWDT
    BTFSS PORT_B,S_DATA
    BCF EEPROM,DI
     NOP
     NOP
    BCF PORT_B,S_CLK
    RETLW 0

BITOUT
    MOVLW 0
    TRIS PORT_B
    BTFSS EEPROM,DO
    GOTO BITLOW
    BSF PORT_B,S_DATA
    GOTO CLKOUT

BITLOW BCF PORT_B,S_DATA
CLKOUT BSF PORT_B,S_CLK
       BCF PORT_B,S_CLK
       RETLW 0


TX   MOVLW .8
     MOVWF COUNT
TXLP BCF EEPROM,DO
     BTFSC TXBUF,7
     BSF EEPROM,DO
     CALL BITOUT
     RLF TXBUF,1
     DECFSZ COUNT,1
     GOTO TXLP
     CALL BITIN
     BTFSC EEPROM,DI
     NOP
     RETLW  0

RX MOVLW B'00001000'
   TRIS PORT_B

   CLRF DATAI
   MOVLW .8
   MOVWF COUNT
CON BCF STATUS,0
    RLF DATAI
   BSF PORT_B,S_DATA
   BSF PORT_B,S_CLK
    BTFSC PORT_B,S_DATA
    BSF DATAI,0
    BCF PORT_B,S_CLK
    DECFSZ COUNT,1
    GOTO CON

   RETLW 0


    END

