
                                  LIST    p=16C84

E         EQU 0     ;      LCD
RS        EQU 1     ;      LCD

RED EQU 3     ;RED
IR  EQU 2     ;IR


status    EQU 3      ;STATUS REGISTER
c equ 0
w equ 0
f equ 1
z equ 2

PORTA     EQU 5
PORT_A    EQU 5      ;PORT A  LCD DATA BUS
PORTB     EQU 6
PORT_B    EQU 6      ;PORT B  CONTROL/MONITOR
DEBOUNCE EQU 0FFH

INDF      EQU 0
RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
FSR       EQU 4

BAUD9600 EQU .30

COUNTER   EQU 0CH    ;ADDRESS  COUNTER
A_N       EQU 0DH    ;ALPHANUMERIC COUNTER
SLOW      EQU 0EH
DATABYTE  EQU 0FH
ASCII     EQU 010H
LCDDATA   EQU 011H
DB1 EQU 012H
GP  EQU 013H
DB2 EQU 014H
COUNTR EQU 015H
DLYCNT EQU 016H
BUFFER EQU 017H
TONE2 EQU 018H
BEAT  EQU 019H
AOUNT  EQU 01AH
SAVE   EQU 01BH
MIN    EQU 01CH


display1 equ 01dh
display2 equ 01eh
display3 equ 01fh


THIRTYTWO EQU 020H   ;MODULUS 32 COUNTER



FLAG            EQU     02AH
beatlsb         equ     029H            ;heartbeat counter,lsb
beatmsb         equ     028H    ;heartbeat counter,msb
aargb0          equ     027H    ;dividend,lsb
aargb1          equ     026H            ;dividend,msb
bargb0          equ     025H            ;divisor,lsb
bargb1          equ     024H            ;divisor,msb
remb0           equ     023H            ;remainder,lsb
remb1           equ     022H            ;remainder,msb


MSEC_20 EQU 02CH
NUMBER EQU 02DH
NUMBER2 EQU 02EH
EVERY100 EQU 02FH





         ORG 0

     CALL SECOND
     MOVLW B'10000'
     TRIS PORT_A

     MOVLW 0
     TRIS PORT_B

     BCF PORT_B,RS
     BCF PORT_B,E
     MOVLW 0FH
     MOVWF PORT_A

     MOVLW B'00000111'
     OPTION

            BCF PORT_B,IR    ;IR OFF
            BSF PORT_B,RED
            CALL SECOND
            BCF PORT_B,RED



     CALL INIT_DISPLAY
     CALL SECOND
     CALL SELECTINIT
     CALL GRAPHICS

 

    BSF FLAG,0   ;HEART



CYCLEALL       BSF PORT_B,RED
     
               call Heartbeat
               call convert

               call display
               GOTO CYCLEALL




Heartbeat
       
       BTFSS PORTA,4 ;wait until signal goes high
        goto Heartbeat


        MOVLW .250  ;250
        MOVWF MIN

AAA     CLRWDT
         CALL MS1
        DECFSZ MIN,1
        GOTO AAA

        MOVLW .100 ;50
        MOVWF MIN

AAB     CLRWDT
         CALL MS1
        DECFSZ MIN,1
        GOTO AAB

        clrf    beatmsb                 ;preset beat registers with 150msec



        movlw   05EH    ;FE
        movwf   beatlsb
        movlw   1
        movwf   beatmsb

pulse  CALL MS1
        INCF beatlsb,1
       btfsc PORTA,4
       goto pulse



vvv

        call MS1             ;wait 1msec


        incf    beatlsb,1               ;increment beatlsb by 1msec
        btfsc   status,z                ;lsb rollover?
        incf    beatmsb,1               ;yes -increment msb
        BTFSS PORTA,4  ;keep looping till signal goes back high
        goto  vvv
        NOP
        retlw 0


MS1

    MOVLW B'00000110';  PRESCALER 00000100 (/256)
    OPTION
   CLRWDT
    MOVLW 4
        MOVWF RTCC
    ;CLRF RTCC       ;LOAD RTCC

YHORT BTFSC RTCC,3   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMPXY
      CLRWDT
      GOTO YHORT
JMPXY CLRF RTCC
       MOVLW .121  ;200
       MOVWF AOUNT
BBB
       DECFSZ AOUNT,1
       GOTO  BBB

          RETLW 0


convert
        ;calculate bpm = 60000/beat (lsb and msb)

        ;Make dividend 60000 == 0xEA60
        movlw  0EAH   ;0EAH            ;msb
        movwf   aargb1
        movlw  060H  ;060H            ;lsb
        movwf   aargb0

        ;Get measured heartbeat values, as divisor
        movf beatmsb,0    ; beatmsb,w ;msb
        movwf bargb1

        movf beatlsb,0
        movwf bargb0

        clrf    remb0           ;initialise remainder registers
        clrf    remb1

        ; do an unsigned 16-bit by 16-bit division
        movlw   0x10
        movwf   COUNTR

Lu16    rlf     aargb1,w
        rlf     remb0,f
        rlf     remb1,f
        movf    bargb0,w
        subwf   remb0,f
        movf    bargb1,w
        btfss   status,c
        incfsz  bargb1,w
        subwf   remb1,f
        btfsc   status,c
        goto    uok16
        movf    bargb0,w
        addwf   remb0,f
        movf    bargb1,w
        btfsc   status,c
        incfsz  bargb1,w
        addwf   remb1,f
        bcf     status,c

uok16   rlf     aargb0,f
        rlf     aargb1,f
        decfsz  COUNTR,f
        goto    Lu16

        ;convert the lsb result of the previous division to unpacked bcd
        movlw   0x08                    ;an 8-bit division
        movwf   COUNTR

        movlw   0x0a                    ;divide the previous lsb result by 10
        movwf   bargb0
        clrf    remb0                   ;initialise remainder

Lu8     rlf     aargb0,w
        rlf     remb0,f
        movf    bargb0,w
        subwf   remb0,f
        btfsc   status,c
        goto    uok8
        addwf   remb0,f
        bcf     status,c
uok8    rlf     aargb0,f
        decfsz  COUNTR,f
        goto    Lu8

        movlw 0x0a                    ;3rd bcd digit - 100's is blank(if not c
         movwf display3

        movf remb0,w
         movwf display1                ;1st bcd digit - 1's

        movf aargb0,w
         movwf display2                ;2nd bcd digit - 10's(if not changed fur

        sublw   0x09                    ;is the quotient >=10?
    ; bnc     $+2                     ;yes -quotient is >=10, so divide by 10
       btfsC status,c

        RETLW 0                        ;go back

        movlw   0x08                    ;an 8-bit division
        movwf   COUNTR

        movlw   0x0a                    ;divide the previous lsb result by 10
        movwf   bargb0
        clrf    remb0                   ;initialise remainder

Lu81    rlf     aargb0,w
        rlf     remb0,f
        movf    bargb0,w
        subwf   remb0,f
        btfsc   status,c
        goto    uok81
        addwf   remb0,f
        bcf     status,c
uok81   rlf     aargb0,f
        decfsz  COUNTR,f
        goto    Lu81

        movf    remb0,w
         movwf  display2                ;2nd bcd digit - 10's

        movf    aargb0,w
         movwf  display3                ;3rd bcd digit - 100's

        RETLW 0                         ;go back



display
    MOVLW 3
    CALL COMMAND

    MOVF display3,0
    CALL BINARY
    CALL WRITE


    MOVF display2,0
    CALL BINARY
    CALL WRITE


    MOVF display1,0
    CALL BINARY
    CALL WRITE

    MOVLW ' '      ;HEART
    CALL WRITE

        BTFSC FLAG,0
     GOTO HEARTON

HEARTOFF
    BSF FLAG,0
    MOVLW 0        ;HEART
    CALL WRITE
    GOTO XXXX

HEARTON
    BCF FLAG,0
    MOVLW 1        ;HEART
    CALL WRITE

XXXX
    MOVLW ' '      ;HEART
    CALL WRITE


     MOVLW 0C0H ; 2ND LINE
     CALL COMMAND


     MOVLW ' '
     CALL WRITE
     MOVLW ' '
     CALL WRITE
     MOVLW ' '
     CALL WRITE
     MOVLW 'B'
     CALL WRITE
     MOVLW '/'
     CALL WRITE
     MOVLW 'M'
     CALL WRITE
     MOVLW 'I'
     CALL WRITE
     MOVLW 'N'
     CALL WRITE


         retlw 0

BINARY
   ADDWF PC
  RETLW '0'
  RETLW '1'
  RETLW '2'
  RETLW '3'
  RETLW '4'
  RETLW '5'
  RETLW '6'
  RETLW '7'
  RETLW '8'
  RETLW '9'
        RETLW '0'



QUARTER
    MOVLW B'00000111';  PRESCALER 00000111 (/256)
    OPTION
    CLRF RTCC
    CLRWDT

    MOVLW 1
    MOVWF THIRTYTWO  ;COUNTER
    CLRF RTCC        ;LOAD RTCC

BHORT BTFSC RTCC,7   ;TEST FOR 128 DECIMAL
                     ;I.E. BIT 7 = HIGH
      GOTO JMP5
      CLRWDT
      GOTO BHORT

JMP5 CLRF RTCC
                     ;32 LOOP COUNTER
    DECFSZ THIRTYTWO,1
    GOTO BHORT
    RETLW 0


SELECTINIT

     MOVLW 0    ;
     CALL COMMAND

     MOVLW 'S'
     CALL WRITE
     MOVLW 'y'
     CALL WRITE
     MOVLW 's'
     CALL WRITE
     MOVLW 't'
     CALL WRITE
     MOVLW 'e'
     CALL WRITE
     MOVLW 'm'
     CALL WRITE

    CALL SECOND


     MOVLW 0C0H ; 2ND LINE
     CALL COMMAND


     MOVLW 'R'
     CALL WRITE
     MOVLW 'E'
     CALL WRITE
     MOVLW 'A'
     CALL WRITE
     MOVLW 'D'
     CALL WRITE
     MOVLW 'Y'
     CALL WRITE
     MOVLW ' '
     CALL WRITE
     MOVLW ' '
     CALL WRITE
     MOVLW ' '
     CALL WRITE

     CALL SECOND

    CALL INIT_DISPLAY

     MOVLW 0    ;
     CALL COMMAND

     MOVLW 'I'
     CALL WRITE
     MOVLW 'N'
     CALL WRITE
     MOVLW 'S'
     CALL WRITE
     MOVLW 'E'
     CALL WRITE
     MOVLW 'R'
     CALL WRITE
     MOVLW 'T'
     CALL WRITE
     MOVLW ' '
     CALL WRITE
     MOVLW ' '
     CALL WRITE


    CALL SECOND


     MOVLW 0C0H ; 2ND LINE
     CALL COMMAND


     MOVLW 'F'
     CALL WRITE
     MOVLW 'I'
     CALL WRITE
     MOVLW 'N'
     CALL WRITE
     MOVLW 'G'
     CALL WRITE
     MOVLW 'E'
     CALL WRITE
     MOVLW 'R'
     CALL WRITE
     MOVLW ' '
     CALL WRITE
     MOVLW ' '
     CALL WRITE

     RETLW 0



INIT_DISPLAY

     MOVLW 1
     CALL COMMAND
     CALL LDELAY

     MOVLW 2
     CALL COMMAND
     CALL LDELAY

     MOVLW 0FH
     CALL COMMAND
    CALL LDELAY
                   ;
     MOVLW 028H  ;028H
     CALL COMMAND

     CALL LDELAY
     RETLW 0


CARIAGERETURN
      MOVLW 0
      CALL WRITE
      RETLW 0


COMMAND
     MOVWF LCDDATA
     SWAPF LCDDATA,0
     MOVWF PORT_A
     BCF PORT_B,RS
     BSF PORT_B,E
     CALL LDELAY
     BCF PORT_B,E
     MOVF LCDDATA,0    ;LSNIBBLE
     MOVWF PORT_A
     BCF PORT_B,RS
     BSF PORT_B,E
     CALL LDELAY
     BCF PORT_B,E
     RETLW 0

WRITE
     MOVWF A_N
     SWAPF A_N,0
     MOVWF PORT_A
     BSF PORT_B,RS
     BSF  PORT_B,E
     CALL DELAY_DATA
     BCF PORT_B,E
     MOVF A_N,0
     MOVWF PORT_A
     BSF PORT_B,RS
     BSF  PORT_B,E
     CALL DELAY_DATA
     BCF PORT_B,E
     RETLW 0

DELAY
       MOVLW BAUD9600
       MOVWF DLYCNT
REDX DECFSZ DLYCNT,1
       GOTO REDX
       NOP
       RETLW 0

LDELAY
       MOVLW B'00000111'
       OPTION
       CLRF RTCC
L_DELAY
       CLRWDT
       BTFSS RTCC,3                        ;7
       GOTO L_DELAY
       RETLW 0

DELAY_DATA
       MOVLW DEBOUNCE
       MOVWF DLYCNT
REDB DECFSZ DLYCNT,1
      goto REDB
       CLRWDT
       RETLW 0



SECOND
     ;1000.23 MS = 32
     MOVLW .32
     MOVWF SLOW
     MOVLW B'00000111'
     OPTION
LONGA CLRF RTCC
LON  CLRWDT
     NOP
     BTFSS RTCC,7
     GOTO LON
     DECFSZ SLOW,1
     GOTO LONGA
     RETLW 0

GRAPHICS
     MOVLW 040H
     CALL COMMAND



     MOVLW 0
     CALL WRITE
     MOVLW 0AH
     CALL WRITE
     MOVLW 015H
     CALL WRITE
     MOVLW 011H
     CALL WRITE
     MOVLW 0AH
     CALL WRITE
     MOVLW 4
     CALL WRITE
     MOVLW 0
     CALL WRITE
     MOVLW 0
     CALL WRITE


     MOVLW 0
     CALL WRITE
     MOVLW 0AH
     CALL WRITE
     MOVLW 01FH
     CALL WRITE
     MOVLW 01FH
     CALL WRITE
     MOVLW 0EH
     CALL WRITE
     MOVLW 4
     CALL WRITE
     MOVLW 0
     CALL WRITE
     MOVLW 0
     CALL WRITE


     RETLW 0




      END

