/* ==========================================================================*/
/* - - - - - - - - - - -  C O M M O N . H  - - - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*	Created   06-14-2004   M. Wheatley                                       */
/*	Modified  08-28-2004   MW                                                */
/*.........................................................................  */
/* Include File of common project definitions                                */
/*.........................................................................  */
#ifndef _COMMON_INCLUDES_
#define _COMMON_INCLUDES_

/*>>>>>>>>>>>>>>>>>>>>>> Global Defines <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/
typedef char boolean;

#define TRUE 1
#define FALSE 0
#define MaxWord 0xFFFF

#define UINT8 unsigned char
#define INT8 char
#define UINT16 unsigned int
#define INT16 int
#define UINT32 unsigned long
#define INT32 long

#define BIT0 (1<<0)
#define BIT1 (1<<1)
#define BIT2 (1<<2)
#define BIT3 (1<<3)
#define BIT4 (1<<4)
#define BIT5 (1<<5)
#define BIT6 (1<<6)
#define BIT7 (1<<7)
#define BIT8 (1<<8)
#define BIT9 (1<<9)
#define BIT10 (1<<10)
#define BIT11 (1<<11)
#define BIT12 (1<<12)
#define BIT13 (1<<13)
#define BIT14 (1<<14)
#define BIT15 (1<<15)

union uword16 {
	struct {
		UINT8 b0;
		UINT8 b1;
	}bytes;
	UINT16 both;
};

struct SEM_STRUCA
{
	unsigned Timer1 :1;
	unsigned KeySwitch :1;
	unsigned CodecRxDataRdy :1;
	unsigned CodecTxDataRdy :1;
	unsigned PlotActive :1;
	unsigned SecRdy :1;
	unsigned SecDataBit :1;
	unsigned SecLocked :1;
	unsigned MinLocked :1;
	unsigned Mode24Hr :1;
	unsigned MinFound :1;
	unsigned HrFound :1;
	unsigned YrFound :1;
	unsigned PMAM :1;
	unsigned SoundAct :1;
};

struct SEM_STRUCB
{
	unsigned WWV :1;
	unsigned Cuckoo :1;
	unsigned TicTock :1;
	unsigned SoundInhibit :1;
	unsigned unused4 :1;
	unsigned unused5 :1;
	unsigned unused6 :1;
	unsigned unused7 :1;
	unsigned unused8 :1;
	unsigned unused9 :1;
	unsigned unused10 :1;
	unsigned unused11 :1;
	unsigned unused12 :1;
	unsigned unused13 :1;
	unsigned unused14 :1;
	unsigned unused15 :1;
};

#define EE_MENU 0xF800
#define EE_LOCALOFFSET 0xF802
#define EE_WWVSEL 0xF804
#define EE_CUCKOOSEL 0xF806
#define EE_TICKTOCKSEL 0xF808
#define EE_MANUALYEAR 0xF80A
#define EE_MANUALHOUR 0xF80C
#define EE_MANUALMIN 0xF80E


#define LED1_ON LATDbits.LATD0=0;
#define LED1_OFF LATDbits.LATD0=1;
#define LED2_ON LATDbits.LATD1=0;
#define LED2_OFF LATDbits.LATD1=1;
#define LED3_ON LATDbits.LATD2=0;
#define LED3_OFF LATDbits.LATD2=1;
#define LED4_ON LATDbits.LATD3=0;
#define LED4_OFF LATDbits.LATD3=1;


#define CLOCK_FREQ4XPLL (1L*7372800L)// Using 4x PLL..PIC Instruction Frequency (Fosc*4/4)
#define CLOCK_FREQ8XPLL (2L*7372800L)// Using 8x PLL..PIC Instruction Frequency (Fosc*8/4)
#define CLOCK_FREQ16XPLL (4L*7372800L) // Using 16x PLL..PIC Instruction Frequency (Fosc*16/4)

#define CLOCK_FREQ CLOCK_FREQ4XPLL
#define SAMPLE_RATE 7200L
#define PROC_BLOCK_SIZE 144	//size of data processing block
#endif // _COMMON_INCLUDES_

