
 

  

#define _RES RB3 
#define _SCE RA3  
#define D_C RA2 
#define SCK RA1 
#define SDI RA0 
 
 




void initlcd(void);					// Initializes the LCD.
void writecom(char);				// Writes a command.
void writedata(char);				// Writes data to DDRAM to illuminate the pixels.
void clockdata(char);				// Clocks in data into the PCD8544 controller.
 				// Erase the DDRAM contents.
void cursorxy(char,char);			// Position cursor to x,y.
void mainrom(void); 
void clearram(void); 
void delay10(char); 
 
 
/* These are global variables accessible by all functions within the firmware. */



void main(void)
{

 
  int roms;
	int i;
  
	TRISA = 0b00000;				// All SCK, SDI, D_C, _SCE and _RES are output pins


	 
   	initlcd(); 
 /*   U   */

 
     for (roms=0; roms<64; roms++) 
{	writedata (0x55);
}

 

	//  demo 3310A test message.... Also a new year's greeting. :)
 	cursorxy(0,1);				// Next line.


  #asm
	nop
 :label
	nop
	goto label
 #endasm
}




void initlcd(void)
{
	_RES = 1;		// Set _RES HIGH.
	_SCE = 1;		// Disable Chip.
	_RES = 0;		// Reset the LCD.

   delay10(10);	// Wait 100ms. 
 
	_RES = 1;		// Awake LCD from RESET state.

	writecom(0x21);		// Activate Chip and H=1.
	writecom(0xc2);		// c2 Set LCD Voltage to     about 7V.   vop
	writecom(0x13);		// Adjust voltage bias.
	writecom(0x20);		// Horizontal addressing and H=0.
	writecom(0x09);		// Activate all segments.
	 clearram();    	// Erase all pixel on the DDRAM.
	writecom(0x08);		// Blank the Display.
	writecom(0x0C);		// Display Normal.
     
	cursorxy(0,0);		// Cursor Home.
	 
}

void clearram(void)
{
	int ddram;
	cursorxy(0,0);											// Cursor Home.
	for (ddram=504;ddram>0;ddram--)	{writedata(0x00);}		// 6*84 = 504 DDRAM addresses.
}



void cursorxy(char x, char y)
{
	writecom(0x40|(y&0x07));	// Y axis
	writecom(0x80|(x&0x7f));	// X axis
}




void writecom(char command_in)
{
	D_C = 0;				// Select Command register.
	_SCE = 0;				// Select Chip.
	clockdata(command_in);	// Clock in command bits.
	_SCE = 1;				// Deselect Chip.	
}

void writedata(char data_in)
{
	D_C = 1;				// Select Data register.
	_SCE = 0;				// Select Chip.
	clockdata(data_in);		// Clock in data bits.
	_SCE = 1;				// Deselect Chip.	
}

void clockdata(char bits_in)
{
	int bitcnt;
	for (bitcnt=8; bitcnt>0; bitcnt--)
		{
			SCK = 0;								// Set Clock Idle level LOW.
			if ((bits_in&0x80)==0x80) {SDI=1;}		// PCD8544 clocks in the MSb first.
			else {SDI=0;}
			SCK = 1;								// Data is clocked on the rising edge of SCK.
			bits_in=bits_in<<1;						// Logical shift data by 1 bit left.
		}
}
 
	
 
 
 

void delay10( char n)
/*
  Delays a multiple of 10 milliseconds using the TMR0 timer
  Clock : 4 MHz   => period T = 0.25 microseconds
  1 IS = 1 Instruction Cycle = 1 microsecond
  error: 0.16 percent
*/
{
    char i;

    OPTION = 7;
    do  {
        clrwdt();  // only if watchdog enabled
        i = TMR0 + 39; /* 256 microsec * 39 = 10 ms */
        while ( i != TMR0)
            ;
    } while ( --n > 0);
}










