 
  
#include <p18f252.h>
#include <delays.h>
 #include "image.h"
extern void ImageDisplay (int, int, int,int);
 
#define ROJO 0b000111 11
#define VERDE 0b11100011
#define AZUL 0b11111100

#define AMARILLO 0b00000011
#define CELESTE 0b11100000

#define NEGRO  0xff
#define BLANCO 0
 
#define  SCLK PORTBbits.RB3
#define  SDATA  PORTBbits.RB2
#define  CS	 PORTBbits.RB1
#define  RESET   PORTBbits.RB0

#define CMD		0
#define DATA	1


#define black  0xff                              //180
#define yellow 0                          // 61



#define DISON       0xaf   
#define DISOFF      0xae   
#define DISNOR      0xa6  
#define DISINV      0xa7  
#define COMSCN      0xbb   
#define DISCTL      0xca   
#define SLPIN       0x95   
#define SLPOUT      0x94   
#define PASET       0x75   
#define CASET       0x15   
#define DATCTL      0xbc   
#define RGBSET8     0xce   
#define RAMWR       0x5c   
#define RAMRD       0x5d   
#define PTLIN       0xa8   
#define PTLOUT      0xa9   
#define RMWIN       0xe0   
#define RMWOUT      0xee   
#define ASCSET      0xaa   
#define SCSTART     0xab   
#define OSCON       0xd1   
#define OSCOFF      0xd2   
#define PWRCTR      0x20   
#define VOLCTR      0x81   
#define VOLUP       0xd6   
#define VOLDOWN     0xd7   
#define TMPGRD      0x82   
#define EPCTIN      0xcd   
#define EPCOUT      0xcc   
#define EPMWR       0xfc   
#define EPMRD       0xfd   
#define EPSRRD1     0x7c   
#define EPSRRD2     0x7d   
#define NOP         0x25    
  





#define  HIGH_COLOR     // Por defecto 64k colores
#define  SCREEN_COLOR   WHITE
#define  USE_GRFCN

#define  GCLCDX         132
#define  GCLCDY         132
  

#define  X_START        1
#define  Y_START        1
#define  X_END          (GCLCDX-1)
#define  Y_END          (GCLCDY-1)

#define  SOFT_RESET     0x01                //  0x01
#define  COLOR_8_BIT    0x02
#define  COLOR_16_BIT   0x05
#define  BOOSTER_ON     0x03
#define  SLEEP_OUT      0x11
#define  DISPLAY_ON     0x29
#define  MEM_CONTROL    0x36
#define  COLMOD			0x3A
#define  SETCON         0x25
#define  ADDRX          0x2A
#define  ADDRY          0x2B
#define  MEMWRITE       0x2C
#define  RGBSET			0x2D


  



#define  BLACK          RGB(0x00, 0x00, 0x00)
#define  WHITE          RGB(0xFF, 0xFF, 0xFF)
#define  RED            RGB(0xFF, 0x00, 0x00)
#define  GREEN          RGB(0x00, 0xFF, 0x00)
#define  BLUE           RGB(0x00, 0x00, 0xFF)
#define  YELLOW         RGB(0xFF, 0xFF, 0x00)
#define  MAGENTA        RGB(0xFF, 0x00, 0xFF)
#define  CYAN           RGB(0x00, 0xFF, 0xFF)
#define  GRAY           RGB(0x80, 0x80, 0x40)
#define  SILVER         RGB(0xA0, 0xA0, 0x80)
#define  GOLD           RGB(0xA0, 0xA0, 0x40)

 
#define SPICommand      0
#define SPIData         1
  


 

extern void SleepMS(int MilliSeconds);

void send( unsigned char nokia_data, unsigned char cd);
void read_rom_table (void);
void read_rom_table2 (void);

void delay10( char n); 
 
void LCD_put_pixel(unsigned char color, unsigned char x, unsigned char y);

void nokia_cs(void);

void nokia_printchar(unsigned char caracter);
void PintarByte(unsigned char bytefornokia);
void nokia_outs(unsigned char * s, unsigned char x, unsigned char y);
void nokia_senddata(unsigned char nokia_data);
void LimpiarPantalla(unsigned char fondo);
 
void main(void) ;
void nokiacolorinit(void);
void plot(void);
 
void gclcd_init(void);
void gclcd_cmd(int  cmd);
 
void gclcd_const(unsigned int  *buffer, unsigned int  count);
void gclcd_cls(void);
void gclcd_setarea(int  startx, int  endx, int  starty, int  endy);
void gclcd_contrast(int  contrast);
void gclcd_img(unsigned int  x, unsigned int  y);
void gclcd_font(void);
int gclcd_putc(int  c);
void gclcd_newline(void);
void gclcd_gotoxy(unsigned int  x, unsigned int  y);
void gclcd_pixel(unsigned int  x, unsigned int  y, int  color);
  

void spi(unsigned char Type, unsigned char dat); 
void ImageDisplay (int x, int y, int Width, int Height);
void GotoXY(unsigned char x, unsigned char y); 
 




void main(void) 
  {
      int   i ;
  char z;
  char q; 
   int roms;
      SleepMS(1000);
    TRISA = 0x00;
    TRISB = 0x00;		// portB is output; (NOKIA LCD = portB) portb4 sw in

      
	PORTB = 0xff;		// all low
            
  
   PORTA=0xff;


  TRISC =0x80;

 PORTC=0xff;


       gclcd_init( );
   
   read_rom_table();
 

  _asm

  sleep

  _endasm






    
}





void send( unsigned char nokia_data, unsigned char cd) { 
 int c;
	CS=0;

	SCLK=0;
    
	if(cd == CMD)
		SDATA=0;
	else
		SDATA=1;
	SCLK=1;

	for (c=0;c<8;c++)
         {
	 
    

	SCLK = 0;								// Set Clock Idle level LOW.
			if ((nokia_data&0x80)==0x80) {SDATA=1;}		// PCD8544 clocks in the MSb first.
			else {SDATA=0;}
	SCLK = 1;								// Data is clocked on the rising edge of SCK.
			nokia_data=nokia_data<<1;	
  
  
 	}

     CS=1;

      
}





void read_rom_table (void)

{
   int roms;
    int number;
 
_asm

    MOVLW 0X09    //10
	MOVFF W,TBLPTRH
	MOVLW 0x00             //0X00
	MOVFF W,TBLPTRL
	MOVLW 0X00
	MOVFF W,TBLPTRU


_endasm

    
 
    send(0x5c, CMD);
  for (roms=0; roms<17163 ;roms++) // 17161
 
 
 {
  _asm
    TBLRD
     MOVFF TABLAT,W
 _endasm 
    number=W;
    asm_rom();



 	send(number, DATA);	

  }  
 }

 

 
  
void gclcd_init(void)
{
      int i;

   CS=1;
  SleepMS(25);

  

     SCLK=1;
     SDATA=0;


   

      SleepMS(10); //RESET
      RESET=0;
      SleepMS(300); //3000
      RESET=1;

   SleepMS(500);  //5000
   CS=1;
    

  send(0xca,CMD);   //spi_command(DISCTL);  // display control
  send(0x03,DATA);    //spi_data(0x00);
  send(32,DATA);     //spi_data(32);
  send(12,DATA);      //spi_data(12);  //...............
  send(0x0a,DATA);     //spi_data(0x00);

  send(0xbb,CMD);      //spi_command(COMSCN);  // comscn
   send(0x01,DATA);      // spi_data(0x01);

  send(0xd1,CMD);       //spi_command(OSCON);  // oscon

  send(0x94,CMD);    //spi_command(SLPOUT);  // sleep out

  send(0x81,CMD);     //spi_command(VOLCTR);  // electronic volume, this is kinda contrast/brightness
  send(0x22,DATA);        //spi_data(5);//ff);       //  this might be different for individual LCDs           fine control 0x28
  send(0x03,DATA);       //spi_data(0x03);//03);     //                                                     course control  3

  send(0x20,CMD);      //spi_command(PWRCTR);  // power ctrl
  send(0x0f,DATA);       //spi_data(0x0f);      //everything on, no external reference resistors


  SleepMS(150);         //delay_ms(100);


  send(0xa7,CMD);      //spi_command(DISINV);  // display mode               a6 reverse


  send(0xbc,CMD);          //spi_command(DATCTL);  // datctl
  send(0x00,DATA);          //spi_data(0x00);
  send(0,DATA);            //spi_data(0);
  send(0x01,DATA);              //spi_data(0x01);
  send(0x00,DATA);           //spi_data(0x00);

  send(0xce,CMD);            //spi_command(RGBSET8);   // setup color lookup table
    // color table
    //RED
    send(0,DATA);        //spi_data(0);
    send(2,DATA);    //spi_data(2);
    send(12,DATA);     //spi_data(4);
    send(6,DATA);           //spi_data(6);
    send(8,DATA);      //spi_data(8);
    send(10,DATA);             //spi_data(10);
    send(12,DATA);      //spi_data(12);
    send(15,DATA);     //spi_data(15);
    // GREEN
    send(0,DATA);           //spi_data(0);
    send(2,DATA);         //spi_data(2);
    send(4,DATA);         //spi_data(4);
    send(6,DATA);    //spi_data(6);
    send(8,DATA);    //spi_data(8);
    send(10,DATA);      //spi_data(10);
    send(12,DATA); 
    send(15,DATA);  
    //BLUE
    send(0,DATA);    //spi_data(0);
    send(5,DATA);     //spi_data(4);
    send(10,DATA);      //spi_data(9);
    send(15,DATA);    //spi_data(15);

    send(0x25,CMD);
    send(0xaf,CMD);

    SleepMS(500);


   send(NOP,CMD);         //spi_command(NOP);  // nop

     send(PASET,CMD);       //spi_command(PASET);   // page start/end ram
      send(0,DATA);         //spi_data(2);            // for some reason starts at 2
      send(130,DATA);          //spi_data(131);          
  
     send(CASET,CMD);           //spi_command(CASET);   // column start/end ram
     send(0,DATA);      //spi_data(0);          
      send(130,DATA);              //spi_data(131);


  send(0xa9,CMD); 



 send(DISON,CMD);
 SleepMS(200);

   for (i=0; i< 125 ; i++);                                  //100

{
   send(0xd6,CMD);
   SleepMS(10);
  }

   
 
}

 
 









   
  
